//Application Window Component Constructor
function ApplicationWindow() {
    
    var modes = [
        Ti.UI.iOS.BLEND_MODE_CLEAR,
        Ti.UI.iOS.BLEND_MODE_COLOR,
        Ti.UI.iOS.BLEND_MODE_COLOR_BURN,
        Ti.UI.iOS.BLEND_MODE_COLOR_DODGE,
        Ti.UI.iOS.BLEND_MODE_COPY,
        Ti.UI.iOS.BLEND_MODE_DARKEN,
        Ti.UI.iOS.BLEND_MODE_DESTINATION_ATOP,
        Ti.UI.iOS.BLEND_MODE_DESTINATION_IN,
        Ti.UI.iOS.BLEND_MODE_DESTINATION_OUT,
        Ti.UI.iOS.BLEND_MODE_DESTINATION_OVER,
        Ti.UI.iOS.BLEND_MODE_DIFFERENCE,
        Ti.UI.iOS.BLEND_MODE_EXCLUSION,
        Ti.UI.iOS.BLEND_MODE_HARD_LIGHT,
        Ti.UI.iOS.BLEND_MODE_HUE,
        Ti.UI.iOS.BLEND_MODE_LIGHTEN,
        Ti.UI.iOS.BLEND_MODE_LUMINOSITY, // Grayscale
        Ti.UI.iOS.BLEND_MODE_MULTIPLY,
        Ti.UI.iOS.BLEND_MODE_NORMAL,
        Ti.UI.iOS.BLEND_MODE_OVERLAY,
        Ti.UI.iOS.BLEND_MODE_PLUS_DARKER,
        Ti.UI.iOS.BLEND_MODE_PLUS_LIGHTER,
        Ti.UI.iOS.BLEND_MODE_SATURATION,
        Ti.UI.iOS.BLEND_MODE_SCREEN,
        Ti.UI.iOS.BLEND_MODE_SOFT_LIGHT,
        Ti.UI.iOS.BLEND_MODE_SOURCE_ATOP, // Masks underneath 
        Ti.UI.iOS.BLEND_MODE_SOURCE_IN,
        Ti.UI.iOS.BLEND_MODE_SOURCE_OUT,
        Ti.UI.iOS.BLEND_MODE_XOR
    ];
    
    
	var self = Ti.UI.createWindow({
		backgroundColor:'#ffffff'
	});

	//construct UI
	var imageMask = Ti.UI.createMaskedImage({
        mask : 'flowerShape.png', // alpha mask
        image : 'summer.png', // image to mask
        mode : Ti.UI.iOS.BLEND_MODE_LUMINOSITY,
        //tint:'#008bf2',
        width: 150, height:150,
    });
    
    self.add(imageMask);
    
    var modeIdx = 0;
    imageMask.addEventListener('click', function() {
       imageMask.mode = modes[modeIdx];
       Ti.API.info('Mode: ' + modes[modeIdx] + ' - idx in Array: ' + modeIdx);
       modeIdx++;
       if (modeIdx === modes.length) {
           modeIdx = 0;
       }
    });
    
    	return self;
}

//make constructor function the public component interface
module.exports = ApplicationWindow;
